diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
index 2a2d7230b..d37924c1d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGlass.java
@@ -7,10 +7,12 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-public class BlockModelGlass<T extends BlockLogic> extends BlockModelTransparent<T>{
+public class BlockModelGlass<T extends BlockLogic> extends BlockModelTransparent<T> {
     public static final int UP = 1 << 0;
     public static final int DOWN = 1 << 1;
     public static final int LEFT = 1 << 2;
@@ -46,49 +48,50 @@ public class BlockModelGlass<T extends BlockLogic> extends BlockModelTransparent
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTexture(final WorldSource blockAccess, final int x, final int y, final int z, final Side side) {
+    public @Nullable IconCoordinate getBlockTexture(final @NotNull WorldSource source, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         if (Minecraft.getMinecraft().gameSettings.connectedGlass.value) {
             final boolean u;
             final boolean d;
             final boolean l;
             final boolean r;
+            TilePos queryPos = new TilePos();
             switch (side) {
                 case SOUTH:
-                    u = blockAccess.getBlockId(x + Side.TOP.getOffsetX(), y + Side.TOP.getOffsetY(), z + Side.TOP.getOffsetZ()) == this.block.id();
-                    d = blockAccess.getBlockId(x + Side.BOTTOM.getOffsetX(), y + Side.BOTTOM.getOffsetY(), z + Side.BOTTOM.getOffsetZ()) == this.block.id();
-                    l = blockAccess.getBlockId(x + Side.WEST.getOffsetX(), y + Side.WEST.getOffsetY(), z + Side.WEST.getOffsetZ()) == this.block.id();
-                    r = blockAccess.getBlockId(x + Side.EAST.getOffsetX(), y + Side.EAST.getOffsetY(), z + Side.EAST.getOffsetZ()) == this.block.id();
+                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
+                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
+                    l = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
+                    r = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
                     break;
                 case NORTH:
-                    u = blockAccess.getBlockId(x + Side.TOP.getOffsetX(), y + Side.TOP.getOffsetY(), z + Side.TOP.getOffsetZ()) == this.block.id();
-                    d = blockAccess.getBlockId(x + Side.BOTTOM.getOffsetX(), y + Side.BOTTOM.getOffsetY(), z + Side.BOTTOM.getOffsetZ()) == this.block.id();
-                    l = blockAccess.getBlockId(x + Side.EAST.getOffsetX(), y + Side.EAST.getOffsetY(), z + Side.EAST.getOffsetZ()) == this.block.id();
-                    r = blockAccess.getBlockId(x + Side.WEST.getOffsetX(), y + Side.WEST.getOffsetY(), z + Side.WEST.getOffsetZ()) == this.block.id();
+                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
+                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
+                    l = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
+                    r = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
                     break;
                 case WEST:
-                    u = blockAccess.getBlockId(x + Side.TOP.getOffsetX(), y + Side.TOP.getOffsetY(), z + Side.TOP.getOffsetZ()) == this.block.id();
-                    d = blockAccess.getBlockId(x + Side.BOTTOM.getOffsetX(), y + Side.BOTTOM.getOffsetY(), z + Side.BOTTOM.getOffsetZ()) == this.block.id();
-                    l = blockAccess.getBlockId(x + Side.NORTH.getOffsetX(), y + Side.NORTH.getOffsetY(), z + Side.NORTH.getOffsetZ()) == this.block.id();
-                    r = blockAccess.getBlockId(x + Side.SOUTH.getOffsetX(), y + Side.SOUTH.getOffsetY(), z + Side.SOUTH.getOffsetZ()) == this.block.id();
+                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
+                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
+                    l = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
+                    r = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
                     break;
                 case EAST:
-                    u = blockAccess.getBlockId(x + Side.TOP.getOffsetX(), y + Side.TOP.getOffsetY(), z + Side.TOP.getOffsetZ()) == this.block.id();
-                    d = blockAccess.getBlockId(x + Side.BOTTOM.getOffsetX(), y + Side.BOTTOM.getOffsetY(), z + Side.BOTTOM.getOffsetZ()) == this.block.id();
-                    l = blockAccess.getBlockId(x + Side.SOUTH.getOffsetX(), y + Side.SOUTH.getOffsetY(), z + Side.SOUTH.getOffsetZ()) == this.block.id();
-                    r = blockAccess.getBlockId(x + Side.NORTH.getOffsetX(), y + Side.NORTH.getOffsetY(), z + Side.NORTH.getOffsetZ()) == this.block.id();
+                    u = source.getBlockId(tilePos.up(queryPos)) == this.block.id();
+                    d = source.getBlockId(tilePos.down(queryPos)) == this.block.id();
+                    l = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
+                    r = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
                     break;
                 case TOP:
                 case BOTTOM:
                 default:
-                    u = blockAccess.getBlockId(x + Side.NORTH.getOffsetX(), y + Side.NORTH.getOffsetY(), z + Side.NORTH.getOffsetZ()) == this.block.id();
-                    d = blockAccess.getBlockId(x + Side.SOUTH.getOffsetX(), y + Side.SOUTH.getOffsetY(), z + Side.SOUTH.getOffsetZ()) == this.block.id();
-                    l = blockAccess.getBlockId(x + Side.WEST.getOffsetX(), y + Side.WEST.getOffsetY(), z + Side.WEST.getOffsetZ()) == this.block.id();
-                    r = blockAccess.getBlockId(x + Side.EAST.getOffsetX(), y + Side.EAST.getOffsetY(), z + Side.EAST.getOffsetZ()) == this.block.id();
+                    u = source.getBlockId(tilePos.north(queryPos)) == this.block.id();
+                    d = source.getBlockId(tilePos.south(queryPos)) == this.block.id();
+                    l = source.getBlockId(tilePos.west(queryPos)) == this.block.id();
+                    r = source.getBlockId(tilePos.east(queryPos)) == this.block.id();
                     break;
             }
             return this.coordinates[(u ? UP : 0) | (d ? DOWN : 0) | (l ? LEFT : 0) | (r ? RIGHT : 0)];
         } else {
-            return super.getBlockTexture(blockAccess, x, y, z, side);
+            return super.getBlockTexture(source, tilePos, side);
         }
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
index e1a58925b..354264236 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelGrass.java
@@ -7,46 +7,51 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T> {
     public static boolean fancyGrass = false;
     public static boolean useOverlay = false;
     private static final IconCoordinate[] overlayIndices = new IconCoordinate[]{
-            null,
-            null,
-            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
-            TextureRegistry.getTexture("minecraft:block/grass/side_overlay")};
+        null,
+        null,
+        TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+        TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+        TextureRegistry.getTexture("minecraft:block/grass/side_overlay"),
+        TextureRegistry.getTexture("minecraft:block/grass/side_overlay")};
     protected IconCoordinate snowSide = TextureRegistry.getTexture("minecraft:block/grass/snowy_side");
+
     public BlockModelGrass(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBounds();
-        boolean didRender = isRetro() ? renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z, 1, 1, 1) : renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
-        if (fancyGrass && !(retroBlockTextures.hasTexture() && isRetro())){
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBdc bounds = this.block.getBounds();
+        boolean didRender = isRetro() ? renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1, 1, 1) : renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
+        if (fancyGrass && !(this.retroBlockTextures.hasTexture() && isRetro())) {
             useOverlay = true;
-            didRender |= renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+            didRender |= renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
             useOverlay = false;
         }
         return didRender;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         GL11.glColor4f(brightness, brightness, brightness, alpha);
         float yOffset = 0.5F;
 
-        AABB bounds = getBlockBoundsForItemRender();
+        AABBdc bounds = getBlockBoundsForItemRender();
         GL11.glTranslatef(-0.5F, 0.0F - yOffset, -0.5F);
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
@@ -72,19 +77,18 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
         tessellator.setNormal(1.0F, 0.0F, 0.0F);
         renderBlocks.renderEastFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.EAST, metadata));
         tessellator.draw();
-        if(renderBlocks.useInventoryTint && !isRetro())
-        {
-            int l = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            float f4 = (float)(l >> 16 & 0xff) / 255F;
-            float f8 = (float)(l >> 8 & 0xff) / 255F;
-            float f9 = (float)(l & 0xff) / 255F;
+        if (renderBlocks.useInventoryTint && !isRetro()) {
+            int l = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            float f4 = (float) (l >> 16 & 0xff) / 255F;
+            float f8 = (float) (l >> 8 & 0xff) / 255F;
+            float f9 = (float) (l & 0xff) / 255F;
             GL11.glColor4f(f4 * brightness, f8 * brightness, f9 * brightness, alpha);
         }
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, 1.0F, 0.0F);
         renderBlocks.renderTopFace(tessellator, bounds, 0.0D, 0.0D, 0.0D, getBlockTextureFromSideAndMetadata(Side.TOP, metadata));
         tessellator.draw();
-        if (fancyGrass && !isRetro()){
+        if (fancyGrass && !isRetro()) {
             useOverlay = true;
             tessellator.startDrawingQuads();
             tessellator.setNormal(0.0F, 0.0F, -1F);
@@ -106,26 +110,27 @@ public class BlockModelGrass<T extends BlockLogic> extends BlockModelStandard<T>
         }
         GL11.glTranslatef(0.5F, 0.5F, 0.5F);
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTexture(WorldSource blockAccess, int x, int y, int z, Side side)
-    {
-        Material material = blockAccess.getBlockMaterial(x, y + 1, z);
-        if ((material == Material.topSnow || material == Material.snow) && (side.getAxis() != Axis.Y)) {
-            return snowSide;
-        } else return super.getBlockTexture(blockAccess, x, y, z, side);
+    public @Nullable IconCoordinate getBlockTexture(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
+        Material material = source.getBlockMaterial(tilePos.up(new TilePos()));
+        if ((material == Materials.TOP_SNOW || material == Materials.SNOW) && (side.getAxis() != Axis.Y)) {
+            return this.snowSide;
+        } else return super.getBlockTexture(source, tilePos, side);
     }
+
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        if (useOverlay){
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        if (useOverlay) {
             return overlayIndices[side.getId()];
         }
         return super.getBlockTextureFromSideAndMetadata(side, data);
     }
+
     @Override
-    public boolean shouldSideBeColored(@NotNull WorldSource worldSource, int x, int y, int z, @NotNull Side side, int meta){
-        Material material = worldSource.getBlockMaterial(x, y + 1, z);
-        if (material == Material.topSnow || material == Material.snow) {
+    public boolean shouldSideBeColored(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos, @NotNull Side side, int meta) {
+        Material material = worldSource.getBlockMaterial(tilePos.up(new TilePos()));
+        if (material == Materials.TOP_SNOW || material == Materials.SNOW) {
             return false;
         }
         return useOverlay || side == Side.TOP;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
index 7c9aab868..71c67f963 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelHorizontalRotation.java
@@ -6,6 +6,7 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicRotatable;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.useless.dragonfly.DisplayPos;
 
@@ -23,17 +24,17 @@ public class BlockModelHorizontalRotation<T extends BlockLogic> extends BlockMod
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data) {
+    public @Nullable IconCoordinate getBlockOverbrightTextureFromSideAndMeta(@NotNull Side side, int data) {
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
-        if (index >= Sides.orientationLookUpHorizontal.length) return overbrightTextures.get(Side.BOTTOM);
+        if (index >= Sides.orientationLookUpHorizontal.length) return this.overbrightTextures.get(Side.BOTTOM);
         return super.getBlockOverbrightTextureFromSideAndMeta(Side.getSideById(index), data);
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data)
     {
         int index = Sides.orientationLookUpHorizontal[6 * Math.min(data & BlockLogicRotatable.MASK_DIRECTION, 5) + side.getId()];
-        if (index >= Sides.orientationLookUpHorizontal.length) return blockTextures.get(Side.BOTTOM);
+        if (index >= Sides.orientationLookUpHorizontal.length) return this.blockTextures.get(Side.BOTTOM);
         return super.getBlockTextureFromSideAndMetadata(Side.getSideById(index), data);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
index 8332ef277..0dd084c01 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJar.java
@@ -8,50 +8,52 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate jarEmpty = TextureRegistry.getTexture("minecraft:block/jar");
     protected IconCoordinate jarFull = TextureRegistry.getTexture("minecraft:block/jar_dirt");
+
     public BlockModelJar(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         // todo: yes, i know this is horrible.
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         float yOffset = 0f;
-        int meta = worldSource.getBlockMetadata(x, y, z);
+        int meta = worldSource.getBlockData(tilePos);
 
-        float extMinX = x + 0.5f - (3f / 16f);
-        float extMinY = y + yOffset;
-        float extMinZ = z + 0.5f - (3f / 16f);
-        float extMaxX = x + 0.5f + (3f / 16f);
-        float extMaxY = y + (0.5f + yOffset);
-        float extMaxZ = z + 0.5f + (3f / 16f);
+        float extMinX = tilePos.x() + 0.5f - (3f / 16f);
+        float extMinY = tilePos.y() + yOffset;
+        float extMinZ = tilePos.z() + 0.5f - (3f / 16f);
+        float extMaxX = tilePos.x() + 0.5f + (3f / 16f);
+        float extMaxY = tilePos.y() + (0.5f + yOffset);
+        float extMaxZ = tilePos.z() + 0.5f + (3f / 16f);
 
-        float fillMaxY = y + (0.5f + yOffset) - (4f / 16f);
+        float fillMaxY = tilePos.y() + (0.5f + yOffset) - (4f / 16f);
 
-        float intMinX = x + 0.5f - (3f / 16f);
-        float intMinY = y + yOffset;
-        float intMinZ = z + 0.5f - (3f / 16f);
-        float intMaxX = x + 0.5f + (3f / 16f);
-        float intMaxY = y + (0.5f + yOffset);
-        float intMaxZ = z + 0.5f + (3f / 16f);
+        float intMinX = tilePos.x() + 0.5f - (3f / 16f);
+        float intMinY = tilePos.y() + yOffset;
+        float intMinZ = tilePos.z() + 0.5f - (3f / 16f);
+        float intMaxX = tilePos.x() + 0.5f + (3f / 16f);
+        float intMaxY = tilePos.y() + (0.5f + yOffset);
+        float intMaxZ = tilePos.z() + 0.5f + (3f / 16f);
 
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, meta);
 
         double texU = texIndex.getIconUMin();
         double texV = texIndex.getIconVMin();
 
-        double onePix = 1f/16;
+        double onePix = 1f / 16;
 
         //exterior shell uvs
         double extSideMinU = texU;
@@ -99,10 +101,10 @@ public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
         tessellator.addVertexWithUV(extMinX, fillMaxY, extMinZ, extTopMinU, extTopMinV);
 
         // Render bottom int
-        tessellator.addVertexWithUV(extMinX, extMinY+0.01F, extMaxZ, extBottomMinU, extBottomMaxV);
-        tessellator.addVertexWithUV(extMaxX, extMinY+0.01F, extMaxZ, extBottomMaxU, extBottomMaxV);
-        tessellator.addVertexWithUV(extMaxX, extMinY+0.01F, extMinZ, extBottomMaxU, extBottomMinV);
-        tessellator.addVertexWithUV(extMinX, extMinY+0.01F, extMinZ, extBottomMinU, extBottomMinV);
+        tessellator.addVertexWithUV(extMinX, extMinY + 0.01F, extMaxZ, extBottomMinU, extBottomMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMinY + 0.01F, extMaxZ, extBottomMaxU, extBottomMaxV);
+        tessellator.addVertexWithUV(extMaxX, extMinY + 0.01F, extMinZ, extBottomMaxU, extBottomMinV);
+        tessellator.addVertexWithUV(extMinX, extMinY + 0.01F, extMinZ, extBottomMinU, extBottomMinV);
 
         // Render sides ext
         tessellator.addVertexWithUV(extMaxX, extMinY, extMinZ, extSideMinU, extSideMaxV);
@@ -139,16 +141,16 @@ public class BlockModelJar<T extends BlockLogic> extends BlockModelStandard<T> {
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int meta)
-    {
-        if(meta == 1)
-            return jarFull;
-        return jarEmpty;
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int meta) {
+        if (meta == 1)
+            return this.jarFull;
+        return this.jarEmpty;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
index 4198dd0ee..ba1badcef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelJarButterfly.java
@@ -8,49 +8,50 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.BlockLogicJarButterfly;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
-public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStandard<T>{
+public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStandard<T> {
 
     public BlockModelJarButterfly(Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, WorldSource worldSource, int x, int y, int z) {
-        int meta = worldSource.getBlockMetadata(x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        int meta = worldSource.getBlockData(tilePos);
         boolean isHanging = (meta & BlockLogicJarButterfly.MASK_HANGING) == 0;
         boolean isAngled = (meta & BlockLogicJarButterfly.MASK_ANGLED) != 0;
 
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-            brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
         float yOffset = isHanging ? 0f : 0.375f;
 
-        float intMinX = x + 0.5f - (2f / 16f);
-        float intMinY = y + yOffset + (1f / 16f);
-        float intMinZ = z + 0.5f - (2f / 16f);
-        float intMaxX = x + 0.5f + (2f / 16f);
-        float intMaxY = y + (0.4375f + yOffset);
-        float intMaxZ = z + 0.5f + (2f / 16f);
-
-        float extMinX = x + 0.5f - (3f / 16f);
-        float extMinY = y + yOffset;
-        float extMinZ = z + 0.5f - (3f / 16f);
-        float extMaxX = x + 0.5f + (3f / 16f);
-        float extMaxY = y + (0.5f + yOffset);
-        float extMaxZ = z + 0.5f + (3f / 16f);
-
-        float hookMinX = x + 0.5f - (2f / 16f);
-        float hookMinZ = z + 0.5f - (2f / 16f);
-        float hookMaxX = x + 0.5f + (2f / 16f);
+        float intMinX = tilePos.x() + 0.5f - (2f / 16f);
+        float intMinY = tilePos.y() + yOffset + (1f / 16f);
+        float intMinZ = tilePos.z() + 0.5f - (2f / 16f);
+        float intMaxX = tilePos.x() + 0.5f + (2f / 16f);
+        float intMaxY = tilePos.y() + (0.4375f + yOffset);
+        float intMaxZ = tilePos.z() + 0.5f + (2f / 16f);
+
+        float extMinX = tilePos.x() + 0.5f - (3f / 16f);
+        float extMinY = tilePos.y() + yOffset;
+        float extMinZ = tilePos.z() + 0.5f - (3f / 16f);
+        float extMaxX = tilePos.x() + 0.5f + (3f / 16f);
+        float extMaxY = tilePos.y() + (0.5f + yOffset);
+        float extMaxZ = tilePos.z() + 0.5f + (3f / 16f);
+
+        float hookMinX = tilePos.x() + 0.5f - (2f / 16f);
+        float hookMinZ = tilePos.z() + 0.5f - (2f / 16f);
+        float hookMaxX = tilePos.x() + 0.5f + (2f / 16f);
         float hookMaxY = intMaxY + (4f / 16f);
-        float hookMaxZ = z + 0.5f + (2f / 16f);
+        float hookMaxZ = tilePos.z() + 0.5f + (2f / 16f);
 
 //        if (isAngled)
 //        {
@@ -95,7 +96,7 @@ public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStan
         double texU = texIndex.getIconUMin();
         double texV = texIndex.getIconVMin();
 
-        double onePix = 1f/16;
+        double onePix = 1f / 16;
 
         //exterior shell uvs
         double extSideMinU = texU;
@@ -175,6 +176,7 @@ public class BlockModelJarButterfly<T extends BlockLogic> extends BlockModelStan
 
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
